routes/admin.php
<?php

use App\Http\Controllers\AdminControllers\AuthController;
use App\Http\Controllers\Auth\LoginController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\AdminControllers\DashboardController;


Route::get('/login', [AuthController::class, 'login_page'])->name('admin.login_page');
Route::post('/login', [AuthController::class, 'login'])->name('admin.login');




/*All Admin Routes List*/
Route::middleware(['auth', 'teacher-admin-access'])->namespace('App\Http\Controllers\AdminControllers')->group(function () {
    Route::get('/dashboard', [DashboardController::class, 'dashboard'])->name('admin.dashboard');

    //students
    Route::resource('students', 'StudentController');
    //teachers
    Route::resource('teachers', 'TeacherController');
    //extensions
    Route::resource('extensions', 'ExtensionController');
    //levels
    Route::resource('levels', 'LevelController');
    //categories
    Route::resource('categories', 'CategoryController');
    //skills
    Route::resource('skills', 'SkillController');
    //courses
    Route::resource('courses', 'CourseController');

    //curriculums
    Route::resource('curriculums', 'CurriculumController');

    //scheduled
    Route::resource('scheduleds', 'ScheduledController');

    //units
    Route::resource('units', 'UnitController');

    //lessons
    Route::resource('lessons', 'LessonController');

    Route::get('moduleFile/destroy/{id}', [\App\Http\Controllers\AdminControllers\CurriculumController::class,'moduleFileDestroy'])->name('moduleFile.destroy');


    //Sprint 3
    //calendars
    Route::resource('calendars', 'CalendarController');
    //calendar Questions
    Route::resource('calendar_questions', 'CalendarQuestionController');
    //calendar answers
    Route::resource('calendar_answers', 'CalendarAnswerController');



    //Sprint 4
    //tools
    Route::resource('tools', 'ToolController');
    //galleries
    Route::resource('galleries', 'GalleryController');
    //zoom
    Route::resource('zooms', 'ZoomController');
    Route::get('zooms/authorize', 'ZoomController@callback')
        ->name('admin.zooms.authorize');

    Route::resource('articles', 'ArticleController');
    Route::resource('article_categories', 'ArticleCategoryController');
    Route::resource('article_tags', 'ArticleTagController');
    Route::resource('contacts', 'ContactController');
    Route::resource('guides', 'GuideController');
    Route::get('/settings', 'SettingController@index')->name('settings.index');
    Route::post('/settings', 'SettingController@update')->name('settings.update');


});

routes/web.php
<?php
//Access Token : glpat-4jA7skgTiFK1KH9fy9Gu

use App\Http\Controllers\Auth\LoginController;
use App\Http\Controllers\WebsiteControllers\ArticleController;
use App\Http\Controllers\WebsiteControllers\CalendarController;
use App\Http\Controllers\WebsiteControllers\CourseController;
use App\Http\Controllers\WebsiteControllers\CurriculumController;
use App\Http\Controllers\WebsiteControllers\GalleryController;
use App\Http\Controllers\WebsiteControllers\GuideController;
use App\Http\Controllers\WebsiteControllers\LessonController;
use App\Http\Controllers\WebsiteControllers\ScheduledController;
use App\Http\Controllers\WebsiteControllers\ToolController;
use App\Http\Controllers\WebsiteControllers\UnitController;
use App\Http\Controllers\WebsiteControllers\ZoomController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\WebsiteControllers\HomePageController;
use App\Http\Controllers\WebsiteControllers\TeacherController;
use App\Http\Controllers\WebsiteControllers\SkillController;
use App\Http\Controllers\WebsiteControllers\CategoryController;
use App\Http\Controllers\StudentControllers\AuthController;
use App\Http\Controllers\StudentControllers\DashboardController;

//Clear Cache facade value:
Route::get('/clear-cache', function() {
    $exitCode = Artisan::call('cache:clear');
    return '<h1>Cache facade value cleared</h1>';
});

//Reoptimized class loader:
Route::get('/optimize', function() {
    $exitCode = Artisan::call('optimize');
    return '<h1>Reoptimized class loader</h1>';
});

//Route cache:
Route::get('/route-cache', function() {
    $exitCode = Artisan::call('route:cache');
    return '<h1>Routes cached</h1>';
});

//Clear Route cache:
Route::get('/route-clear', function() {
    $exitCode = Artisan::call('route:clear');
    return '<h1>Route cache cleared</h1>';
});

//Clear View cache:
Route::get('/view-clear', function() {
    $exitCode = Artisan::call('view:clear');
    return '<h1>View cache cleared</h1>';
});

//Clear Config cache:
Route::get('/config-cache', function() {
    $exitCode = Artisan::call('config:cache');
    return '<h1>Clear Config cleared</h1>';
});

//Clear Config cache:
Route::get('/config-clear', function() {
    $exitCode = Artisan::call('config:clear');
    return '<h1>Clear Config cleared</h1>';
});



//Auth::routes();
Route::get('/student/register', [AuthController::class, 'register_page'])->name('website.student.register_page');
Route::post('/student/register', [AuthController::class, 'register'])->name('website.student.register');
Route::get('/student/login', [AuthController::class, 'login_page'])->name('website.student.login_page');
Route::post('/student/login', [AuthController::class, 'login'])->name('website.student.login');
Route::post('/logout', [LoginController::class, 'logout'])->name('logout');
Route::get('/forget_password', [AuthController::class, 'forget_password'])->name('website.forget_password');
Route::post('/reset_password', [AuthController::class, 'reset_password'])->name('website.reset_password');
Route::get('/reset_password/{token}', [AuthController::class, 'change_reset_password'])->name('website.change_reset_password');
Route::post('/change_reset_password', [AuthController::class, 'change_reset_password_post'])->name('website.change_reset_password');
Route::get('/verification_email/{encryptID}', [AuthController::class, 'verification_email'])->name('website.verification_email');

Route::get('/', [HomePageController::class, 'index'])->name('website.index');
Route::get('/contact-us', [HomePageController::class, 'contacts'])->name('website.contacts');
Route::post('/contact-us', [HomePageController::class, 'contacts_submit'])->name('website.contacts.submit');
Route::get('/guides', [GuideController::class, 'index'])->name('website.guides.index');
Route::get('/guides/{id}', [GuideController::class, 'show'])->name('website.guides.show');
Route::post('/student/alreadyRating', [HomePageController::class, 'alreadyRating'])->name('website.student.alreadyRating');


Route::middleware('auth')->group(function(){
    Route::get('/teachers', [TeacherController::class, 'index'])->name('website.teachers.index');
    Route::get('/teacher/{id}', [TeacherController::class, 'show'])->name('website.teachers.show');
    Route::get('/skills', [SkillController::class, 'index'])->name('website.skills.index');
    Route::get('/skill/{id}', [SkillController::class, 'show'])->name('website.skills.show');
    Route::get('/categories', [CategoryController::class, 'index'])->name('website.categories.index');
    Route::get('/category/{id}', [CategoryController::class, 'show'])->name('website.categories.show');
    Route::get('/courses', [CourseController::class, 'index'])->name('website.courses.index');
    Route::get('/course/{id}', [CourseController::class, 'show'])->name('website.courses.show');
    Route::get('/curriculums', [CurriculumController::class, 'index'])->name('website.curriculums.index');
    Route::get('/curriculum/{id}', [CurriculumController::class, 'show'])->name('website.curriculums.show');
    Route::get('/scheduled/{id}', [ScheduledController::class, 'show'])->name('website.scheduleds.show');
    Route::get('/unit/{id}', [UnitController::class, 'show'])->name('website.units.show');
    Route::get('/lesson/{id}', [LessonController::class, 'show'])->name('website.lessons.show');

    Route::post('/student_upload_course_file_answers/{id}', [CourseController::class, 'studentUploadCourseFileAnswers'])->name('website.courses.studentUploadCourseFileAnswers');
    Route::get('/student_delete_course_file_answers/{id}', [CourseController::class, 'studentDeleteCourseFileAnswers'])->name('website.courses.deleteUserFile');

    Route::post('/student_ask_question_course/{id}', [CourseController::class, 'studentAskQuestion'])->name('website.courses.studentAskQuestion');
    Route::get('/student_delete_question_course/{id}', [CourseController::class, 'studentDeleteCourseQuestion'])->name('website.courses.deleteUserQuestion');

    Route::get('/myFavorite/{id}', [CourseController::class, 'addToFavorite'])->name('website.courses.addToFavorite');
    Route::get('/myFavorite', [CourseController::class, 'myFavorite'])->name('website.courses.myFavorite');
    Route::get('/removeFromFavorite/{id}', [CourseController::class, 'removeFromFavorite'])->name('website.courses.removeFromFavorite');
    Route::post('/rating/{id}', [CourseController::class, 'rating'])->name('website.courses.rating');



    //Calendars Routes
    Route::get('/calendar/show/{id}', [CalendarController::class, 'show'])->name('website.calendars.show');
    Route::get('/calendar/go_exam/{id}', [CalendarController::class, 'go_exam'])->name('website.calendars.go');
    Route::post('/calendar/save_exam/{id}', [CalendarController::class, 'save_exam'])->name('website.calendar.save_exam');
    Route::get('/calendar/finished_exam/thanks', [CalendarController::class, 'thanks_after_finished'])->name('website.calendars.thanks');


    //Spint 4
    Route::get('/tools', [ToolController::class, 'index'])->name('website.tools.index');
    Route::get('/galleries', [GalleryController::class, 'index'])->name('website.galleries.index');
    Route::get('/galleries/{id}', [GalleryController::class, 'show'])->name('website.galleries.show');
    Route::get('/meetings', [ZoomController::class, 'index'])->name('website.meetings.index');

    Route::get('/articles', [ArticleController::class, 'index'])->name('website.articles.index');
    Route::get('/articles/{id}', [ArticleController::class, 'show'])->name('website.articles.show');


    //Search
    Route::get('/search_results', [HomePageController::class, 'search_results'])->name('website.search_results');
    Route::post('/searchPage', [HomePageController::class, 'searchPage'])->name('website.searchPage');




});



/*All Normal Students Routes List*/
Route::middleware(['auth', 'user-access:student'])->group(function () {
    Route::get('/student/dashboard', [DashboardController::class, 'dashboard'])->name('website.student.dashboard');
    Route::post('/student/update', [DashboardController::class, 'update'])->name('website.student.update');

    Route::get('/student/calendars', [DashboardController::class, 'myCalendars'])->name('website.student.calendars');


    //Sprint 5
    Route::get('/my-appointments', [DashboardController::class, 'appointments'])->name('website.student.appointments');
    Route::post('/student/createGoogleMeet', [DashboardController::class, 'createGoogleMeet'])->name('website.student.createGoogleMeet');
    Route::post('/student/approve_or_reject_meet/{id}', [DashboardController::class, 'approve_or_reject_meet'])->name('website.student.approve_or_reject_meet');


});

app/Models/ArticleCategory.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class ArticleCategory extends Model
{
    use HasFactory;
    protected $guarded = [''];


    public function articles()
    {
        return $this->hasMany('App\Models\Article', 'category_id')->where('status', 'yes');
    }

}

app/Http/Controllers/AdminControllers/ArticleCategoryController.php
<?php

namespace App\Http\Controllers\AdminControllers;

use App\Http\Controllers\Controller;
use App\Http\Requests\ArticleCategoryRequest;
use App\Http\Traits\HelperTrait;
use Illuminate\Http\Request;
use App\Http\Requests\ArticleRequest;
use App\Models\ArticleCategory;
use Illuminate\Support\Facades\File;

class ArticleCategoryController extends Controller
{
    use HelperTrait;

    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        if($this->isTeacher())
        {
            $content = ArticleCategory::where('teacher_id', $this->userId())->paginate($this->paginate);
        }
        else
        {
            $content = ArticleCategory::paginate($this->paginate);
        }
        return view('admin_dashboard.article_categories.index' , compact('content'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        return view('admin_dashboard.article_categories.create');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(ArticleCategoryRequest $request)
    {
        $data = $request->validated();
        $data['teacher_id'] = $this->userId();
        ArticleCategory::create($data);
        toastr()->success($this->insertMsg, 'نجح', ['timeOut' => 5000]);
        return redirect()->back();
    }


    /**
     * Show the form for editing the specified resource.
     */
    public function edit(ArticleCategory $articleCategory)
    {
        $content =  $articleCategory;
        $this->editPermission($content);
        return view('admin_dashboard.article_categories.edit', compact('content'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(ArticleCategoryRequest $request, ArticleCategory $articleCategory)
    {
        $data = $request->validated();
        $articleCategory->update($data);
        toastr()->success($this->updateMsg, 'نجح', ['timeOut' => 5000]);
        return redirect()->back();
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(ArticleCategory $articleCategory)
    {
        $articleCategory->delete();
        toastr()->success($this->deleteMsg, 'نجح', ['timeOut' => 5000]);
        return redirect()->back();
    }
}

resources/views/admin_dashboard/article_categories/create.blade.php
@extends('admin_dashboard.layout.master')
@section('Page_Title')  أقسام المقالات | إضافة   @endsection

@section('content')

    <div class="row">
        <div class="col-lg-12 mx-auto">
            <div class="card">
                <div class="card-body">
                    <div class="d-flex align-items-center">
                        <h5 class="mb-0"> <i class="bi bi-grid-fill"></i> أقسام المقالات | اضافة عنصر جديد </h5>
                    </div>
                    <div class="row g-3 mt-4">
                        <div class="col-12">
                            <div class="card shadow-none bg-light border">
                                <div class="card-body">
                                    <form class="row g-3" id="validateForm" method="post" enctype="multipart/form-data"
                                    action="{{route('article_categories.store')}}">
                                        @csrf
                                        @include('admin_dashboard.inputs.name')
                                        @include('admin_dashboard.inputs.add_btn')
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div><!--end row-->
                </div>
            </div>
        </div>
    </div>

@endsection

@push('scripts')
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.19.5/jquery.validate.min.js" integrity="sha512-rstIgDs0xPgmG6RX1Aba4KV5cWJbAMcvRCVmglpam9SoHZiUCyQVDdH2LPlxoHtrv17XWblE/V/PP+Tr04hbtA==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>

<script>
    $(document).ready(function () {
        $("#validateForm").validate({
            rules: {
                name: {
                    required: true,
                }


            },
            messages: {
                name: {
                    required: "الحقل مطلوب",
                }

            }
        });
    });
</script>
@endpush

resources/views/admin_dashboard/article_categories/edit.blade.php
@extends('admin_dashboard.layout.master')
@section('Page_Title') أقسام  المقالات | تعديل   @endsection

@section('content')

    <div class="row">
        <div class="col-lg-12 mx-auto">
            <div class="card">
                <div class="card-body">
                    <div class="d-flex align-items-center">
                        <h5 class="mb-0"> <i class="bi bi-grid-fill"></i>  أقسام المقالات  | تعديل <small class="text-warning">({{$content->name}})</small> </h5>
                    </div>
                    <div class="row g-3 mt-4">
                        <div class="col-12">
                            <div class="card shadow-none bg-light border">
                                <div class="card-body">
                                    <form class="row g-3" id="validateForm" method="post" enctype="multipart/form-data"
                                          action="{{route('article_categories.update', $content->id)}}">
                                        @method('put')
                                        @csrf
                                        @include('admin_dashboard.inputs.edit_name')
                                        @include('admin_dashboard.inputs.edit_btn')
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div><!--end row-->
                </div>
            </div>
        </div>
    </div>

@endsection

@push('scripts')
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.19.5/jquery.validate.min.js" integrity="sha512-rstIgDs0xPgmG6RX1Aba4KV5cWJbAMcvRCVmglpam9SoHZiUCyQVDdH2LPlxoHtrv17XWblE/V/PP+Tr04hbtA==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>

    <script>
        $(document).ready(function () {
            $("#validateForm").validate({
                rules: {
                    name: {
                        required: true,
                    }


                },
                messages: {
                    name: {
                        required: "الحقل مطلوب",
                    }

                }
            });
        });
    </script>
@endpush

resources/views/admin_dashboard/article_categories/index.blade.php
@extends('admin_dashboard.layout.master')
@section('Page_Title') أقسام المقالات @endsection

@section('content')


    <div class="card">
        <div class="card-body">
            <div class="d-flex align-items-center">
                <h5 class="mb-0"> <i class="bi bi-grid-fill"></i> أقسام المقالات </h5>
                <div class="ms-auto position-relative">
                    <a href="{{route('article_categories.create')}}" class="btnIcon btn btn-outline-primary px-5"><i class="lni lni-circle-plus"></i> أضف عنصر جديد </a>
                </div>
            </div>
            <div class="table-responsive mt-4">
                <table class="table align-middle">
                    <thead class="table-secondary">
                    <tr>
                        <th>#</th>
                        <th>اسم القسم</th>
                        <th>التحكم</th>
                    </tr>
                    </thead>
                    <tbody>
                        @forelse($content as $con)
                        <tr>
                            <td>{{$con->id}}</td>
                            <td>{{$con->name}}</td>
                            <td>
                                <div class="table-actions d-flex align-items-center gap-3 fs-6">
                                    <a href="{{route('article_categories.edit', $con->id)}}" class="text-warning" data-bs-toggle="tooltip" data-bs-placement="bottom"
                                       title="تعديل"><i class="bi bi-pencil-fill"></i></a>
                                    <a href="javascript:;"  data-bs-toggle="modal" data-bs-target="#deleteItem{{$con->id}}" class="text-danger" data-bs-toggle="tooltip"
                                       data-bs-placement="bottom" title="حذف"><i class="bi bi-trash-fill"></i></a>
                                    <div class="modal fade" id="deleteItem{{$con->id}}" tabindex="-1" aria-labelledby="link{{$con->id}}" aria-hidden="true">
                                        <div class="modal-dialog modal-dialog-centered">
                                            <div class="modal-content">
                                                <div class="modal-header">
                                                    <h5 class="modal-title" id="link{{$con->id}}">هل أنت متأكد من حذف هذا العنصر ؟</h5>
                                                    <button class="btn-close" type="button" data-bs-dismiss="modal" aria-label="Close"></button>
                                                </div>
                                                <div class="modal-footer">
                                                    <button class="btn btn-outline-default btn-sm me-2" type="button" data-bs-dismiss="modal">لا</button>
                                                    <form action="{{route('article_categories.destroy',$con->id)}}" method="POST">
                                                        @method('DELETE')
                                                        @csrf
                                                        <button type="submit" class="btn btn-outline-danger btn-sm" type="button">نعم</button>
                                                    </form>
                                                </div>
                                            </div>
                                        </div>
                                    </div>

                                </div>
                            </td>
                        </tr>
                        @empty
                            <tr>
                                <td colspan="6" class="text-center">
                                    <p> لا يوجد بيانات </p>
                                </td>
                            </tr>
                        @endforelse
                    </tbody>
                </table>
                <div>
                    {{$content->links()}}
                </div>
            </div>
        </div>
    </div>


@endsection